package cn.iocoder.yudao.module.mes.service.feedingplan;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.mes.controller.admin.feedingplan.vo.FeedingRecordPlanPageReqVO;
import cn.iocoder.yudao.module.mes.controller.admin.feedingplan.vo.FeedingRecordPlanSaveReqVO;
import cn.iocoder.yudao.module.mes.dal.dataobject.feedingplan.FeedingRecordPlanDO;
import cn.iocoder.yudao.module.mes.dal.mysql.feedingplan.FeedingRecordPlanMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.FEEDING_RECORD_PLAN_NOT_EXISTS;

/**
 * 投料分配计划 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class FeedingRecordPlanServiceImpl implements FeedingRecordPlanService {

    @Resource
    private FeedingRecordPlanMapper feedingRecordPlanMapper;


    @Override
    public Long createFeedingRecordPlan(FeedingRecordPlanSaveReqVO createReqVO) {
        // 插入
        FeedingRecordPlanDO feedingRecordPlan = BeanUtils.toBean(createReqVO, FeedingRecordPlanDO.class);
        feedingRecordPlanMapper.insert(feedingRecordPlan);
        // 返回
        return feedingRecordPlan.getId();
    }

    @Override
    public void updateFeedingRecordPlan(FeedingRecordPlanSaveReqVO updateReqVO) {
        // 校验存在
        validateFeedingRecordPlanExists(updateReqVO.getId());
        // 更新
        FeedingRecordPlanDO updateObj = BeanUtils.toBean(updateReqVO, FeedingRecordPlanDO.class);
        feedingRecordPlanMapper.updateById(updateObj);
    }

    @Override
    public void deleteFeedingRecordPlan(Long id) {
        // 校验存在
        validateFeedingRecordPlanExists(id);
        // 删除
        feedingRecordPlanMapper.deleteById(id);
    }

    private void validateFeedingRecordPlanExists(Long id) {
        if (feedingRecordPlanMapper.selectById(id) == null) {
            throw exception(FEEDING_RECORD_PLAN_NOT_EXISTS);
        }
    }

    @Override
    public FeedingRecordPlanDO getFeedingRecordPlan(Long id) {
        return feedingRecordPlanMapper.selectById(id);
    }

    @Override
    public PageResult<FeedingRecordPlanDO> getFeedingRecordPlanPage(FeedingRecordPlanPageReqVO pageReqVO) {
        return feedingRecordPlanMapper.selectPage(pageReqVO);
    }

    @Override
    public BigDecimal selectSumBy(Long planId, Long itemId) {
        return feedingRecordPlanMapper.selectSumBy(planId, itemId);
    }
}